// Flexconnect
// Copyright 2016,2017 Hardy Lau, DL1GLH
//
// v171213-0.93 Alpha
//
// Standalone interface for interconnection of
// + Flexradio 6300/6500/6700 
// + S.P.E. Expert 2K-FA
// + Ultrabeam dynamic antenna
//
// Running on Banana Pro
// This part passes request from webserver to ubconnect (cgi)
//

/*
 Copyright 2016,2017 Hardy Lau, DL1GLH

 Redistribution and use in source and binary forms, with or without modification,
 are permitted provided that the following conditions are met:

 1. Redistributions of source code must retain the above copyright notice,
    this list of conditions and the following disclaimer.

 2. Redistributions in binary form must reproduce the above copyright notice,
    this list of conditions and the following disclaimer in the documentation
    and/or other materials provided with the distribution.

 3. Neither the name of the copyright holder nor the names of its contributors
    may be used to endorse or promote products derived from this software without
    specific prior written permission.

 THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
 INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY
 OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
 EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

#include <stdio.h>
#include <stdlib.h>
#include <netdb.h>
#include <netinet/in.h>
#define _GNU_SOURCE
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <dirent.h>
#include <signal.h>
#include <unistd.h>
#include <time.h>

#define DEBUG
#undef DEBUG

//Create a file /run/flexconnect/ub-request-%ownname
//
int ubrequest( char* what) 
{
 DIR *dir;
 struct dirent *dp;
 char *file_name;
 char file_name_full_path[200];
 char file_name_full_path_new[200];
 int fd;

 //Create dir - doesn't matter if already exist
 mkdir( "/run/flexconnect", 0777);

 //Delete all old request files
 dir = opendir( "/run/flexconnect");
 while ((dp=readdir(dir)) != NULL) {
   file_name = dp->d_name;
   if( strstr( file_name, "ub-request-")) {
     strcpy( file_name_full_path, "/run/flexconnect/");
     strcat( file_name_full_path, file_name);
     //Delete all request files
     unlink( file_name_full_path);
   }
 }
 closedir( dir);

 //Create file with request information
 sprintf( file_name_full_path_new, "/run/flexconnect/ub-request-%s", strstr( what, "ub"));
 fd = creat( file_name_full_path_new, 0777);
 close( fd);
}

//Main
//
int main( int argc, char *argv[])
{
 printf( "Content-type: text/html\n\n");
 fflush(stdout);
 printf( "<html><head></head><body>\n");
 printf( "<p>One moment...</p>");
 printf( "</body></html>");   
 ubrequest( argv[0]); 
}
